﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms.Design;
using System.Drawing;
using System.Drawing.Design;
using System.ComponentModel;
using PropertyGridDemo.Objects;

namespace PropertyGridDemo.Controls
{
    public class ShapeTypeEditor : UITypeEditor
    {
        private static Shape[] _shapes = new Shape[3] { new Circle(Size.Empty, Color.Red), new Box(Size.Empty, Color.Red), new Triangle(Size.Empty, Color.Red) };

        public ShapeTypeEditor()
        {
        }
        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {            
            IWindowsFormsEditorService edSvc = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            Shape shape = value as Shape;
            if (edSvc != null)
            {
                ShapeListBoxEditor dropdown = new ShapeListBoxEditor(shape, edSvc);
                dropdown.Items.Add(_shapes[0]);
                dropdown.Items.Add(_shapes[1]);
                dropdown.Items.Add(_shapes[2]);                
                edSvc.DropDownControl(dropdown);
                return dropdown.Selection;
            }
            return value;
        }
        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.DropDown;
        }
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return true;
        }
        public override void PaintValue(PaintValueEventArgs e)
        {
            Shape shape = e.Value as Shape;
            if (shape != null)
            {
                Rectangle rect = e.Bounds;
                rect.Inflate(-2, -2);
                shape.ShapeSize = new Size(rect.Height, rect.Height);
                shape.DrawShape(e.Graphics, rect.X + 3, rect.Y);
            }
        }
    }
}
