﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Threading;
using PropertyGridDemo.Properties;

namespace PropertyGridDemo
{
    public class DescriptionGlobalAttribute : DescriptionAttribute
    {
        private bool m_bTranslate = true;

        public DescriptionGlobalAttribute(string id)
            : base(id)
        {
        }
        public override string Description
        {
            get
            {
                if (m_bTranslate)
                {
                    DescriptionValue = Resources.ResourceManager.GetString(base.Description, Thread.CurrentThread.CurrentCulture);
                    m_bTranslate = false;
                }
                return DescriptionValue;
            }
        }
    }
    public class CategoryGlobalAttribute : CategoryAttribute
    {
        private bool m_bTranslate = true;

        public CategoryGlobalAttribute(string id)
            : base(id)
        {
        }
        protected override string GetLocalizedString(string value)
        {
            if (m_bTranslate)
            {
                m_bTranslate = false;
                string resultado = Resources.ResourceManager.GetString(value, Thread.CurrentThread.CurrentCulture);
                return resultado;
            }
            else
            {
                return value;
            }
        }
    }
    public class DisplayNameGlobalAttribute : DisplayNameAttribute
    {
        private bool m_bTranslate = true;

        public DisplayNameGlobalAttribute(string id)
            : base(id)
        {
        }
        public override string DisplayName
        {
            get
            {
                if (m_bTranslate)
                {
                    DisplayNameValue = Resources.ResourceManager.GetString(base.DisplayName, Thread.CurrentThread.CurrentCulture);
                    m_bTranslate = false;
                }
                return DisplayNameValue;
            }
        }
    }
}
