﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Globalization;
using System.ComponentModel;

namespace PropertyGridDemo.Objects
{
    public class EnumerableTypeConverter : TypeConverter
    {
        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            if (sourceType == typeof(string))
            {
                return true;
            }
            return base.CanConvertFrom(context, sourceType);
        }
        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
        {
            if (value.GetType() == typeof(string))
            {
                return context.PropertyDescriptor.GetValue(context.Instance);
            }
            return base.ConvertFrom(context, culture, value);
        }
        public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType)
        {
            if (destinationType == typeof(string))
            {
                IEnumerable ienum = value as IEnumerable;
                if (ienum != null)
                {
                    int cnt = 0;
                    string result = "";
                    string c = "";
                    foreach (object obj in ienum)
                    {
                        if (cnt < 3)
                        {
                            result += c + obj.ToString();
                            c = ", ";
                        }
                        cnt++;
                        if (cnt > 3)
                        {
                            result += "...";
                            break;
                        }
                    }
                    return result;
                }
            }
            return base.ConvertTo(context, culture, value, destinationType);
        }
    }
}
